<?php
class controller_component_unicomments extends component {


	protected function email($mailTo, $mailFrom, $nameFrom, $subject, $text, $charset='utf-8') {
		$headers ="Date: ".date("D, j M Y G:i:s")." +0700\r\n"; 
		$headers.="From: =?".$charset."?Q?".str_replace("+","_",str_replace("%","=",urlencode($nameFrom)))."?= <".$mailFrom.">\r\n";
		$headers.="X-Mailer: The Bat! (v3.99.3) Professional\r\n"; 
		$headers.="X-Priority: 3 (Normal)\r\n";
		$headers.="Message-ID: <172562218.".date("YmjHis")."@mail.ru>\r\n";
		$headers.="MIME-Version: 1.0\r\n";
		$headers.="Content-Type: text/html; charset=".$charset."\r\n";
		return mail($mailTo,$subject,$text,$headers);
	}



	public function action_index($unanswered = false) {
		$current_page = isset($this->url['params']['page']) ? $this->url['params']['page'] : 0;
		$limit = $this->component_config['comments_per_page_backend'];
		if ($limit < 0) $limit = 10;
		$comments_count = $this->model->count_comments($unanswered);
		$pages_amount = ceil($comments_count/$limit);
		if ($current_page >= $pages_amount) $current_page = $pages_amount - 1;
		if ($current_page < 0) $current_page = 0;
		
		$this->data['comments']			= $this->model->read_comments($current_page*$limit, $limit, $unanswered);
		$this->data['pages_amount']		= $pages_amount;
		$this->data['comments_count']	= $comments_count;
		$this->data['unanswered']		= $unanswered;
		$this->data['current_page']		= $current_page;

		$this->page['head'] = $this->add_css_file(SITE_URL.'/modules/components/unicomments/back_end/views/style.css');
		$this->page['html'] = $this->load_view();
		return $this->page;
	}




	public function action_remove() {
		$return = isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER'] : SITE_URL;
		if (isset($this->url['params']['id'])) $this->model->delete_comment(intval($this->url['params']['id']));
		$this->redirect($return);
	}




	public function action_edit() {
		$return = isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER'] : SITE_URL;
		$return = isset($_POST['return_addr']) ? $_POST['return_addr'] : $return;

		$comment = false;
		if (isset($this->url['params']['id'])) $comment = $this->model->get_comment(intval($this->url['params']['id']));
		if ($comment !== false) {
			if (isset($_POST['submit'])) {
				$this->model->set_comment_text(
					intval($this->url['params']['id']),
					htmlspecialchars($_POST['text'])
				);
				$this->model->set_answer(
					intval($this->url['params']['id']),
					htmlspecialchars($_POST['answer'])
				);
				if (isset($_POST['email_to_user']) && $_POST['email_to_user'] == 'on' && $comment['email'] != '') {
					$this->email(
						$comment['email'],
						$this->component_config['from_addr'],
						$this->component_config['from_name'],
						'Вам ответили на сайте '.SITE_URL,
						htmlspecialchars($_POST['answer'])
					);
				}
				$this->redirect($return);
			} else {
				$this->data['comment'] = $comment;
				$this->data['form_url'] = $this->url['request_uri'];
				$this->data['return'] = $return;
				$this->page['head'] = $this->add_css_file(SITE_URL.'/modules/components/unicomments/back_end/views/style.css');
				$this->page['html'] = $this->load_view('edit');
				return $this->page;
			}
		} else {
			$this->redirect($return);
		}
	}



	public function action_unanswered() {
		return $this->action_index(true);
	}
}
?>